var largeur; var hauteur; var channels; var slices; var frames;
var channel, slice, frame;
var fps;var pixelW; var pixelH; var pixelD; var unit; var Tunits;
var nom_ori; var Nbits;
var FI, Stype, xSel, ySel;
var isNewSel;
var StypeOld, xSelOld, ySelOld,largeurOld,hauteurOld;
var channelOld, sliceOld, frameOld;
var pos, Ztab, prop;

var sVer = "3D Profile v1.0";
var sCop = "Copyright 2015-2017 F.GANNIER - C.PASQUALIN";

macro "Plot TimeProfile" {
	init_Common_values();
	if (nSlices==1)
		exit("<html>"
			+"<h1>"+sVer+"</h1>"
			+" <u>Error</u>: This tool require a stack!"
		);
	time = newArray(nSlices);
	Xtitle = "slices";
	if (fps!=0) {
		for (i=0; i<nSlices; i++) time[i] = (i)/fps;
		Xtitle = "Time ("+Tunits+")";	
	} else if (pixelD!=1) {
		for (i=0; i<nSlices; i++) time[i] = (i)*pixelD;
		Xtitle = "Depth ("+unit+")";
	} else for (i=0; i<nSlices; i++) time[i] = (i);
	do {
		isNewSel=false;
		
		Ztab = GetZprofile(1, nSlices);
		Stack.getPosition(channel, slice, frame);		
		nomW = "Z-profile of " + nom_ori;
		Plot.create(nomW, Xtitle, "Mean", time, Ztab);
		
setBatchMode(true);
		selectWindow(nom_ori);

		Plot.setColor("green");
		Plot.setLineWidth(1);
		for(i=1;i<=nSlices;i++) {
			setSlice(i);
			if (indexOf(getMetadata("Label"),"sync")!= -1) {
				Plot.drawLine(time[i],0,time[i],65536);
			}
			if (indexOf(getMetadata("Label"),"mark")!= -1) {
				Plot.setColor("blue");
				Plot.setLineWidth(2);
				Plot.drawLine(time[i],0,time[i],65536);
				Plot.setColor("green");
				Plot.setLineWidth(1);
			}
		}
		setBatchMode(false);
//IJ.log("Channel number: " + channel + " ; Slice number: " + slice + " ; Frame number: "+frame);
//IJ.log("FPS: " + fps);
//IJ.log("Time unit: " + Tunits);
//IJ.log("Frame interval: " + FI);
		Stack.setPosition(channel, slice, frame);
		Plot.setColor("red");
		Plot.setLineWidth(3);
		if (slices==1)
			Plot.drawLine((frame-1)*FI, 0, (frame-1)*FI, 65536);
		else { 
			if (fps==0) 
				Plot.drawLine(slice-1, 0, slice-1, 65536);
			else 
				Plot.drawLine((slice-1)/fps, -1000000, (slice-1)/fps, 1000000);
		}
		Plot.setColor("black");
		Plot.setLineWidth(1);
		if (!isOpen(nomW)) {
			Plot.show(); 
		} else {
			Plot.update();
		}
		do {
			wait(200);
			if (getTitle() == nom_ori)
				isSelectionChange();
			if(!isOpen(nom_ori)) exit;
			if(!isOpen(nomW)) exit;
		} while (!isNewSel)
	} while(1);
}

function init_Common_values() {
	xSel=0; ySel=0;
	getDimensions(largeur, hauteur, channels, slices, frames);
	if (slices>1 && frames>1)
		exit("<html>"
			+"<h1>"+sVer+"</h1>"
			+" <u>Error</u>: Not works on 4D image file!"
			+"<ul>"
			+"<li>tip: if this is an error, use <b>Sht+P</b> to correct it."
			+"</ul>");
	Stack.getPosition(channel, slice, frame);
	fps = 0; 	prop = 1;
	FI = Stack.getFrameInterval();
	if (FI==0)
		fps = Stack.getFrameRate();
	if (frames>1)
		if (FI==0)
			exit("Frames found but frame interval is 0\nCorrect it, (use \"Ctl-Maj-P\")");

	Stack.getUnits(X, Y, Z, Tunits, Value);
	getVoxelSize(pixelW, pixelH, pixelD, unit);
	if (pixelD==1E-13) pixelD=0;
	pixelW = roundn(pixelW, 7);
	pixelH = roundn(pixelH, 7);
	nom_ori = getTitle();
	Nbits = bitDepth();
	if (startsWith(Tunits,"ms")) prop = 1000;
	if (startsWith(Tunits,"us")) prop = 1000000;
	if (startsWith(Tunits,"micros")) prop = 1000000;
	if (startsWith(Tunits,"ns")) prop = 1000000000;
	if (fps==0 && FI>0)	fps=prop/FI;
	
	isSelectionChange();
}

function roundn(num, n) {
	return parseFloat(d2s(num,n))
}

function isSelectionChange() {
	StypeOld = Stype; isNewSel=false; pos = false;
	xSelOld=xSel; ySelOld=ySel;largeurOld=largeur;hauteurOld=hauteur;
	channelOld=channel; sliceOld=slice; frameOld=frame;
	Stack.getPosition(channel, slice, frame);
	Stype = selectionType();
	if (Stype==5) {
		getLine(xSel, ySel, largeur, hauteur, lineWidth);
	 } else {
		 getSelectionBounds(xSel, ySel, largeur, hauteur);
	 }
	 if(Stype!=StypeOld) isNewSel=true;
	 if(largeur!=largeurOld) isNewSel=true;
	 if(hauteur!=hauteurOld) isNewSel=true;
	 if(xSel!=xSelOld) isNewSel=true;
	 if(ySel!=ySelOld) isNewSel=true;
	 if(channelOld!=channel) { isNewSel=true; pos = true; }
	 if(slice!=sliceOld) { isNewSel=true; pos = true; }
	 if(frame!=frameOld) { isNewSel=true; pos = true; }
}

function GetZprofile(start, end) {
	if (!pos) {
		Stack.getPosition(channel, slice, frame);
		Ztab = newArray(end-start+1);
		for(zi=start;zi<=end;zi++) {
			showProgress(zi/(end-start));
			setSlice(zi);
			getStatistics(area, mean);
			Ztab[zi-start] = mean;
		}
		Stack.setPosition(channel, slice, frame);
	}
	return Ztab;
}
