//This macro presents en example of online video analysis triggered by a synchronization signal on the BNC-1 (DSR) of the input box.
//BNC-2 can be used instead if "Sync.newDSR" is replaced by "Sync.newCTS"

nPoints = 100; // corresponds to the number of image to analyze following synchronization signal receipt

HRwait = 1000; // precision in s
vid = getImageID();
img = getTitle();
timedemo = newArray(nPoints); // this array contains the time base 
	for ( i = 0; i < nPoints; i++) timedemo[i] = i;
a1demo = newArray(nPoints); // this array contains points to plot
IJ.log("start online analysis");
setKeyDown("none");
is_running = true;
tempsT = parseInt(call("HRtime.gettime"));
startTime = tempsT;
lastTime = tempsT;
while (is_running) { // analysis go on while "alt" key is not pressed

	while (call("ij.Prefs.get", "Sync.newDSR","false") == "false") { // this loop wait for "sync" signal on DSR (BNC-1); CTS can also be used if prefered
		wait(1);
		if(isKeyDown("alt")) is_running = false;
	}

	call("ij.Prefs.set", "Sync.newDSR","false"); // indicate in IJPrefs file that "sync" signal as been read
	
	/////////////////////////////////////
	// action started at "synch" reception
	IJ.log("sync received");
	setBatchMode(true);
	for (jj=0;jj<nPoints;jj++){ // analysis works on the following "nPoints" images
		while (call("ij.Prefs.get", "Cam.newImage","false") == "false") {
			tempsT = parseInt(call("HRtime.sleep",d2s(tempsT,16), d2s(HRwait,16)));	
		}
		call("ij.Prefs.set", "Cam.newImage","false"); // indicate in IJPrefs file that the new image as been read
		
		if (isOpen(vid)) 
			a1demo[jj]=mean(vid); // call the analysis function and write the result in the array
		else is_running = false;
	}
	tempsT = parseInt(call("HRtime.gettime"));
	IJ.log(((tempsT - startTime)/1000000)+" sec - (laps : " +((tempsT-lastTime)/1000)+" msec)");
	lastTime = tempsT;
	// following lines update the analysis plot
	Plot.create("Plot", "time (image)", "Mean grey level (AU)");
	Plot.add("lines", timedemo, a1demo);
	setBatchMode(false);	
	Plot.update;
	if(isKeyDown("alt")) is_running = false;
	// action end  
	/////////////////////////////////////
}
IJ.log("Macro ended");


function mean(vid) { // function which computes the mean grey level value of the selection
	selectImage(vid);
	if (selectionType == 0 || selectionType == 5) {
		profile = getProfile();
		sum=0.0;
		for (i=0; i<profile.length; i++)
			sum += profile[i];
		return sum / profile.length;
	}
	return 0;
}

